Index: root.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/root.cc,v
retrieving revision 2.7
diff -u -p -r2.7 root.cc
--- root.cc	2001/11/13 01:49:32	2.7
+++ root.cc	2001/12/20 12:36:03
@@ -35,6 +35,7 @@ static const char *cvsid =
 #include "mount.h"
 #include "concat.h"
 #include "log.h"
+#include "root.h"
 
 static int rb[] = { IDC_ROOT_TEXT, IDC_ROOT_BINARY, 0 };
 static int su[] = { IDC_ROOT_SYSTEM, IDC_ROOT_USER, 0 };
@@ -143,64 +144,56 @@ dialog_cmd (HWND h, int id, HWND hwndctl
     case IDC_ROOT_BROWSE:
       browse (h);
       break;
-
-    case IDOK:
-      save_dialog (h);
-
-      if (!directory_is_absolute ())
-	{
-	  note (IDS_ROOT_ABSOLUTE);
-	  break;
-	}
-
-      if (directory_is_rootdir ())
-	if (IDNO == yesno (IDS_ROOT_SLASH))
-	  break;
-
-      if (directory_has_spaces ())
-	if (IDNO == yesno (IDS_ROOT_SPACE))
-	  break;
-
-      NEXT (IDD_LOCAL_DIR);
-      break;
-
-    case IDC_BACK:
-      save_dialog (h);
-      NEXT (IDD_SOURCE);
-      break;
-
-    case IDCANCEL:
-      NEXT (0);
-      break;
     }
   return 0;
 }
 
-static BOOL CALLBACK
-dialog_proc (HWND h, UINT message, WPARAM wParam, LPARAM lParam)
+bool
+RootPage::Create ()
 {
-  switch (message)
-    {
-    case WM_INITDIALOG:
-      load_dialog (h);
-      return FALSE;
-    case WM_COMMAND:
-      return HANDLE_WM_COMMAND (h, wParam, lParam, dialog_cmd);
-    }
-  return FALSE;
+  return PropertyPage::Create (NULL, dialog_cmd, IDD_ROOT);
 }
 
 void
-do_root (HINSTANCE h)
+RootPage::OnInit ()
 {
-  int rv = 0;
   if (!get_root_dir ())
     read_mounts ();
-  rv = DialogBox (h, MAKEINTRESOURCE (IDD_ROOT), 0, dialog_proc);
-  if (rv == -1)
-    fatal (IDS_DIALOG_FAILED);
+  load_dialog (GetHWND ());
+}
 
+long
+RootPage::OnNext ()
+{
+  HWND h = GetHWND ();
+
+  save_dialog (h);
+
+  if (!directory_is_absolute ())
+    {
+      note (h, IDS_ROOT_ABSOLUTE);
+      return -1;
+    }
+  else if (directory_is_rootdir () && (IDNO == yesno (h, IDS_ROOT_SLASH)))
+    return -1;
+  else if (directory_has_spaces () && (IDNO == yesno (h, IDS_ROOT_SPACE)))
+    return -1;
+
+  NEXT (IDD_LOCAL_DIR);
+
   log (0, "root: %s %s %s", get_root_dir (),
        (root_text == IDC_ROOT_TEXT) ? "text" : "binary",
        (root_scope == IDC_ROOT_USER) ? "user" : "system");
+
+  return 0;
+}
+
+long
+RootPage::OnBack ()
+{
+  HWND h = GetHWND ();
+
+  save_dialog (h);
+  NEXT (IDD_SOURCE);
+  return 0;
 }
Index: root.h
===================================================================
RCS file: root.h
diff -N root.h
--- /dev/null	Tue May  5 13:32:27 1998
+++ root.h	Thu Dec 20 04:36:03 2001
@@ -0,0 +1,23 @@
+#ifndef CINSTALL_ROOT_H
+#define CINSTALL_ROOT_H
+
+#include "proppage.h"
+
+class RootPage:public PropertyPage
+{
+public:
+  RootPage ()
+  {
+  };
+  virtual ~ RootPage ()
+  {
+  };
+
+  bool Create ();
+
+  void OnInit ();
+  virtual long OnNext ();
+  virtual long OnBack ();
+};
+
+#endif // CINSTALL_ROOT_H
Index: site.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/site.cc,v
retrieving revision 2.10
diff -u -p -r2.10 site.cc
--- site.cc	2001/12/03 22:22:09	2.10
+++ site.cc	2001/12/20 12:36:03
@@ -25,6 +25,7 @@ static const char *cvsid =
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <process.h>
 
 #include "dialog.h"
 #include "resource.h"
@@ -38,6 +39,12 @@ static const char *cvsid =
 
 #include "port.h"
 
+#include "site.h"
+#include "propsheet.h"
+
+#include "threebar.h"
+extern ThreeBarProgressPage Progress;
+
 #define NO_IDX (-1)
 #define OTHER_IDX (-2)
 
@@ -101,7 +108,12 @@ load_dialog (HWND h)
       int index = SendMessage (listbox, LB_FINDSTRING, (WPARAM) - 1,
 			       (LPARAM) site_list[n]->displayed_url);
       if (index != LB_ERR)
-	SendMessage (listbox, LB_SELITEMRANGE, TRUE, (index << 16) | index);
+	{
+	  // Highlight the selected item
+	  SendMessage (listbox, LB_SELITEMRANGE, TRUE, (index << 16) | index);
+	  // Make sure it's fully visible
+	  SendMessage (listbox, LB_SETCARETINDEX, index, FALSE);
+	}
     }
   check_if_enable_next (h);
 }
@@ -167,63 +179,18 @@ dialog_cmd (HWND h, int id, HWND hwndctl
     case IDC_URL_LIST:
       check_if_enable_next (h);
       break;
-
-    case IDOK:
-      save_dialog (h);
-      if (mirror_idx == OTHER_IDX)
-	NEXT (IDD_OTHER_URL);
-      else
-	{
-	  save_site_url ();
-	  NEXT (IDD_S_LOAD_INI);
-	}
-      break;
-
-    case IDC_BACK:
-      save_dialog (h);
-      NEXT (IDD_NET);
-      break;
-
-    case IDCANCEL:
-      NEXT (0);
-      break;
     }
   return 0;
 }
 
-static BOOL CALLBACK
-dialog_proc (HWND h, UINT message, WPARAM wParam, LPARAM lParam)
-{
-  int j;
-  HWND listbox;
-  switch (message)
-    {
-    case WM_INITDIALOG:
-      listbox = GetDlgItem (h, IDC_URL_LIST);
-      for (size_t i = 1; i <= all_site_list.number (); i++)
-	{
-	  j =
-	    SendMessage (listbox, LB_ADDSTRING, 0,
-			 (LPARAM) all_site_list[i]->displayed_url);
-	  SendMessage (listbox, LB_SETITEMDATA, j, i);
-	}
-      j = SendMessage (listbox, LB_ADDSTRING, 0, (LPARAM) "Other URL");
-      SendMessage (listbox, LB_SETITEMDATA, j, OTHER_IDX);
-      load_dialog (h);
-      return FALSE;
-    case WM_COMMAND:
-      return HANDLE_WM_COMMAND (h, wParam, lParam, dialog_cmd);
-    }
-  return FALSE;
-}
-
 static int
-get_site_list (HINSTANCE h)
+get_site_list (HINSTANCE h, HWND owner)
 {
   char mirror_url[1000];
+
   if (LoadString (h, IDS_MIRROR_LST, mirror_url, sizeof (mirror_url)) <= 0)
     return 1;
-  char *mirrors = get_url_to_string (mirror_url);
+  char *mirrors = get_url_to_string (mirror_url, owner);
   dismiss_url_status_dialog ();
   if (!mirrors)
     return 1;
@@ -320,24 +287,106 @@ get_saved_sites ()
 
 }
 
-void
-do_site (HINSTANCE h)
+static void
+do_download_site_info_thread (void *p)
 {
-  int rv = 0;
+  HANDLE *context;
+  HINSTANCE hinst;
+  HWND h;
+  context = (HANDLE *) p;
+
+  hinst = (HINSTANCE) (context[0]);
+  h = (HWND) (context[1]);
 
   if (all_site_list.number () == 0)
-    if (get_site_list (h))
-      {
-	NEXT (IDD_NET);
-	return;
-      }
+    {
+      if (get_site_list (hinst, h))
+	{
+	  // Error: Couldn't download the site info.  Go back to the Net setup page.
+	  NEXT (IDD_NET);
+	  return;
+	}
+    }
+
+  // Everything worked, go to the site select page
+  NEXT (IDD_SITE);
+
+  // Tell the progress page that we're done downloading
+  Progress.PostMessage (WM_APP_SITE_INFO_DOWNLOAD_COMPLETE, 0, next_dialog);
+
+  _endthread ();
+}
 
+static HANDLE context[2];
+
+void
+do_download_site_info (HINSTANCE hinst, HWND owner)
+{
+
+  context[0] = hinst;
+  context[1] = owner;
+
+  _beginthread (do_download_site_info_thread, 0, context);
+
+}
+
+bool
+SitePage::Create ()
+{
+  return PropertyPage::Create (NULL, dialog_cmd, IDD_SITE);
+}
+
+void
+SitePage::OnInit ()
+{
+  HWND h = GetHWND ();
+  int j;
+  HWND listbox;
+
   get_saved_sites ();
+
+  listbox = GetDlgItem (IDC_URL_LIST);
+  for (size_t i = 1; i <= all_site_list.number (); i++)
+    {
+      j =
+	SendMessage (listbox, LB_ADDSTRING, 0,
+		     (LPARAM) all_site_list[i]->displayed_url);
+      SendMessage (listbox, LB_SETITEMDATA, j, i);
+    }
+  j = SendMessage (listbox, LB_ADDSTRING, 0, (LPARAM) "Other URL");
+  SendMessage (listbox, LB_SETITEMDATA, j, OTHER_IDX);
+  load_dialog (h);
+}
 
-  rv = DialogBox (h, MAKEINTRESOURCE (IDD_SITE), 0, dialog_proc);
-  if (rv == -1)
-    fatal (IDS_DIALOG_FAILED);
+long
+SitePage::OnNext ()
+{
+  HWND h = GetHWND ();
 
-  for (size_t n = 1; n <= site_list.number (); n++)
-    log (0, "site: %s", site_list[n]->url);
+  save_dialog (h);
+  if (mirror_idx == OTHER_IDX)
+    NEXT (IDD_OTHER_URL);
+  else
+    {
+      save_site_url ();
+      NEXT (IDD_S_LOAD_INI);
+
+      for (size_t n = 1; n <= site_list.number (); n++)
+	log (0, "site: %s", site_list[n]->url);
+
+      Progress.SetActivateTask (WM_APP_START_SETUP_INI_DOWNLOAD);
+      return IDD_INSTATUS;
+    }
+
+  return 0;
+}
+
+long
+SitePage::OnBack ()
+{
+  HWND h = GetHWND ();
+
+  save_dialog (h);
+  NEXT (IDD_NET);
+  return 0;
 }
Index: site.h
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/site.h,v
retrieving revision 2.1
diff -u -p -r2.1 site.h
--- site.h	2001/12/03 22:22:09	2.1
+++ site.h	2001/12/20 12:36:03
@@ -17,17 +17,41 @@
 #define _SITE_H_
 
 /* required to parse this file */
-#include <strings.h>
+#include <string.h>
+#include <stdlib.h>
 #include "list.h"
 
+#include "proppage.h"
+
+class SitePage:public PropertyPage
+{
+public:
+  SitePage ()
+  {
+  };
+  virtual ~ SitePage ()
+  {
+  };
+
+  bool Create ();
+
+  void OnInit ();
+  long OnNext ();
+  long OnBack ();
+};
+
+void do_download_site_info (HINSTANCE h, HWND owner);
+
 class site_list_type
 {
 public:
-  site_list_type () : url(0), displayed_url (0), key (0) {};
+  site_list_type ():url (0), displayed_url (0), key (0)
+  {
+  };
   site_list_type (char const *);
   /* workaround for missing placement new in gcc 2.95 */
   void init (char const *);
-  ~site_list_type () 
+  ~site_list_type ()
   {
     if (url)
       free (url);
@@ -42,9 +66,9 @@ public:
 };
 
 /* user chosen sites */
-extern list <site_list_type, const char *, strcasecmp> site_list;
+extern list < site_list_type, const char *, strcasecmp > site_list;
 /* potential sites */
-extern list <site_list_type, const char *, strcasecmp> all_site_list;
+extern list < site_list_type, const char *, strcasecmp > all_site_list;
 
 void save_site_url ();
 
Index: source.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/source.cc,v
retrieving revision 2.9
diff -u -p -r2.9 source.cc
--- source.cc	2001/12/20 11:49:54	2.9
+++ source.cc	2001/12/20 12:36:03
@@ -31,6 +31,8 @@ static const char *cvsid =
 #include "log.h"
 #include "package_db.h"
 
+#include "source.h"
+
 static int rb[] =
   { IDC_SOURCE_NETINST, IDC_SOURCE_DOWNLOAD, IDC_SOURCE_CWD, 0 };
 
@@ -45,7 +47,8 @@ save_dialog (HWND h)
 {
   source = rbget (h, rb);
   packagedb db;
-  db.task = source == IDC_SOURCE_DOWNLOAD ? PackageDB_Download : PackageDB_Install;
+  db.task =
+    source == IDC_SOURCE_DOWNLOAD ? PackageDB_Download : PackageDB_Install;
 }
 
 static BOOL
@@ -60,65 +63,61 @@ dialog_cmd (HWND h, int id, HWND hwndctl
       save_dialog (h);
       break;
 
-    case IDOK:
-      save_dialog (h);
-      if (source == IDC_SOURCE_DOWNLOAD)
-	NEXT (IDD_LOCAL_DIR);
-      else
-	NEXT (IDD_ROOT);
-      break;
-
-    case IDC_BACK:
-      save_dialog (h);
-      NEXT (0);
-      break;
-
-    case IDCANCEL:
-      NEXT (0);
-      break;
-
     default:
       break;
     }
   return 0;
 }
 
-static BOOL CALLBACK
-dialog_proc (HWND h, UINT message, WPARAM wParam, LPARAM lParam)
+bool
+SourcePage::Create ()
 {
-  switch (message)
-    {
-    case WM_INITDIALOG:
-      load_dialog (h);
-      // Check to see if any radio buttons are selected. If not, select a default.
-      if (
-	  (!SendMessage
-	   (GetDlgItem (h, IDC_SOURCE_DOWNLOAD), BM_GETCHECK, 0,
-	    0) == BST_CHECKED)
-	  && (!SendMessage (GetDlgItem (h, IDC_SOURCE_CWD), BM_GETCHECK, 0, 0)
-	      == BST_CHECKED))
-	{
-	  SendMessage (GetDlgItem (h, IDC_SOURCE_NETINST), BM_SETCHECK,
-		       BST_CHECKED, 0);
-	}
-      return FALSE;
-    case WM_COMMAND:
-      return HANDLE_WM_COMMAND (h, wParam, lParam, dialog_cmd);
-    }
-  return FALSE;
+  return PropertyPage::Create (NULL, dialog_cmd, IDD_SOURCE);
 }
 
 void
-do_source (HINSTANCE h)
+SourcePage::OnActivate ()
 {
-  int rv = 0;
-  /* source = IDC_SOURCE_CWD; */
   if (!source)
     source = IDC_SOURCE_NETINST;
-  rv = DialogBox (h, MAKEINTRESOURCE (IDD_SOURCE), 0, dialog_proc);
-  if (rv == -1)
-    fatal (IDS_DIALOG_FAILED);
+  load_dialog (GetHWND ());
+  // Check to see if any radio buttons are selected. If not, select a default.
+  if ((!SendMessage
+       (GetDlgItem (IDC_SOURCE_DOWNLOAD), BM_GETCHECK, 0,
+	0) == BST_CHECKED)
+      && (!SendMessage (GetDlgItem (IDC_SOURCE_CWD), BM_GETCHECK, 0, 0)
+	  == BST_CHECKED))
+    {
+      SendMessage (GetDlgItem (IDC_SOURCE_NETINST), BM_SETCHECK,
+		   BST_CHECKED, 0);
+    }
+}
 
+long
+SourcePage::OnNext ()
+{
+  HWND h = GetHWND ();
+
+  save_dialog (h);
+  if (source == IDC_SOURCE_DOWNLOAD)
+    {
+      // If all we're doing is downloading,skip the root directory page
+      return IDD_LOCAL_DIR;
+    }
+
+  return 0;
+}
+
+long
+SourcePage::OnBack ()
+{
+  save_dialog (GetHWND ());
+  return 0;
+}
+
+void
+SourcePage::OnDeactivate ()
+{
   log (0, "source: %s",
        (source == IDC_SOURCE_DOWNLOAD) ? "download" :
        (source == IDC_SOURCE_NETINST) ? "network install" : "from cwd");
Index: source.h
===================================================================
RCS file: source.h
diff -N source.h
--- /dev/null	Tue May  5 13:32:27 1998
+++ source.h	Thu Dec 20 04:36:03 2001
@@ -0,0 +1,43 @@
+#ifndef CINSTALL_SOURCE_H
+#define CINSTALL_SOURCE_H
+
+/*
+ * Copyright (c) 2001, Gary R. Van Sickle.
+ *
+ *     This program is free software; you can redistribute it and/or modify
+ *     it under the terms of the GNU General Public License as published by
+ *     the Free Software Foundation; either version 2 of the License, or
+ *     (at your option) any later version.
+ *
+ *     A copy of the GNU General Public License can be found at
+ *     http://www.gnu.org/
+ *
+ * Written by Gary R. Van Sickle <g.r.vansickle@worldnet.att.net>
+ *
+ */
+
+// This is the header for the SourcePage class, which lets the user
+// select Download+Install, Download, or Install From Local Directory.
+
+
+#include "proppage.h"
+
+class SourcePage:public PropertyPage
+{
+public:
+  SourcePage ()
+  {
+  };
+  virtual ~ SourcePage ()
+  {
+  };
+
+  bool Create ();
+
+  void OnActivate ();
+  void OnDeactivate ();
+  long OnNext ();
+  long OnBack ();
+};
+
+#endif
Index: splash.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/splash.cc,v
retrieving revision 2.6
diff -u -p -r2.6 splash.cc
--- splash.cc	2001/11/13 01:49:32	2.6
+++ splash.cc	2001/12/20 12:36:03
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000, Red Hat, Inc.
+ * Copyright (c) 2001, Gary R. Van Sickle.
  *
  *     This program is free software; you can redistribute it and/or modify
  *     it under the terms of the GNU General Public License as published by
@@ -9,71 +9,31 @@
  *     A copy of the GNU General Public License can be found at
  *     http://www.gnu.org/
  *
- * Written by DJ Delorie <dj@cygnus.com>
+ * Written by Gary R. Van Sickle <g.r.vansickle@worldnet.att.net>
  *
  */
 
-/* The purpose of this file is to display the program name, version,
-   copyright notice, and project URL. */
+// This is the implementation of the SplashPage class.  Since the splash page
+// has little to do, there's not much here.
 
-#if 0
-static const char *cvsid =
-  "\n%%% $Id: splash.cc,v 2.6 2001/11/13 01:49:32 rbcollins Exp $\n";
-#endif
-
-#include "win32.h"
 #include <stdio.h>
-#include "dialog.h"
-#include "resource.h"
-#include "msg.h"
 #include "version.h"
+#include "resource.h"
+#include "cistring.h"
+#include "splash.h"
 
-static void
-load_dialog (HWND h)
+bool
+SplashPage::Create ()
 {
-  char buffer[100];
-  HWND v = GetDlgItem (h, IDC_VERSION);
-  sprintf (buffer, "Setup.exe version %s",
-	   version[0] ? version : "[unknown]");
-  SetWindowText (v, buffer);
+  return PropertyPage::Create (IDD_SPLASH);
 }
 
-static BOOL
-dialog_cmd (HWND h, int id, HWND hwndctl, UINT code)
+void
+SplashPage::OnInit ()
 {
-  switch (id)
-    {
-
-    case IDOK:
-      NEXT (IDD_SOURCE);
-      break;
-
-    case IDCANCEL:
-      NEXT (0);
-      break;
-    }
-  return 0;
-}
+  cistring ver;
 
-static BOOL CALLBACK
-dialog_proc (HWND h, UINT message, WPARAM wParam, LPARAM lParam)
-{
-  switch (message)
-    {
-    case WM_INITDIALOG:
-      load_dialog (h);
-      return TRUE;
-    case WM_COMMAND:
-      return HANDLE_WM_COMMAND (h, wParam, lParam, dialog_cmd);
-    }
-  return FALSE;
-}
+  ver.Format (IDS_VERSION_INFO, version[0] ? version : "[unknown]");
 
-void
-do_splash (HINSTANCE h)
-{
-  int rv = 0;
-  rv = DialogBox (h, MAKEINTRESOURCE (IDD_SPLASH), 0, dialog_proc);
-  if (rv == -1)
-    fatal (IDS_DIALOG_FAILED);
+  SetWindowText (GetDlgItem (IDC_VERSION), ver.c_str ());
 }
Index: splash.h
===================================================================
RCS file: splash.h
diff -N splash.h
--- /dev/null	Tue May  5 13:32:27 1998
+++ splash.h	Thu Dec 20 04:36:03 2001
@@ -0,0 +1,38 @@
+#ifndef CINSTALL_SPLASH_H
+#define CINSTALL_SPLASH_H
+
+/*
+ * Copyright (c) 2001, Gary R. Van Sickle.
+ *
+ *     This program is free software; you can redistribute it and/or modify
+ *     it under the terms of the GNU General Public License as published by
+ *     the Free Software Foundation; either version 2 of the License, or
+ *     (at your option) any later version.
+ *
+ *     A copy of the GNU General Public License can be found at
+ *     http://www.gnu.org/
+ *
+ * Written by Gary R. Van Sickle <g.r.vansickle@worldnet.att.net>
+ *
+ */
+
+// This is the header for the SplashPage class.  Since the splash page
+// has little to do, there's not much here.
+
+#include "proppage.h"
+
+class SplashPage:public PropertyPage
+{
+public:
+  SplashPage ()
+  {
+  };
+  virtual ~ SplashPage ()
+  {
+  };
+
+  bool Create ();
+  void OnInit ();
+};
+
+#endif // CINSTALL_SPLASH_H
Index: threebar.cc
===================================================================
RCS file: threebar.cc
diff -N threebar.cc
--- /dev/null	Tue May  5 13:32:27 1998
+++ threebar.cc	Thu Dec 20 04:36:03 2001
@@ -0,0 +1,199 @@
+/*
+ * Copyright (c) 2001, Gary R. Van Sickle.
+ *
+ *     This program is free software; you can redistribute it and/or modify
+ *     it under the terms of the GNU General Public License as published by
+ *     the Free Software Foundation; either version 2 of the License, or
+ *     (at your option) any later version.
+ *
+ *     A copy of the GNU General Public License can be found at
+ *     http://www.gnu.org/
+ *
+ * Written by Gary R. Van Sickle <g.r.vansickle@worldnet.att.net>
+ *
+ */
+
+// This is the implementation of the ThreeBarProgressPage class.  It is a fairly generic
+// progress indicator property page with three progress bars.
+
+#include "win32.h"
+#include "commctrl.h"
+#include "resource.h"
+
+#include "dialog.h"
+#include "site.h"
+
+#include "propsheet.h"
+#include "threebar.h"
+
+bool
+ThreeBarProgressPage::Create ()
+{
+  return PropertyPage::Create (IDD_INSTATUS);
+}
+
+void
+ThreeBarProgressPage::OnInit ()
+{
+  // Get HWNDs to the dialog controls
+  ins_action = GetDlgItem (IDC_INS_ACTION);
+  ins_pkgname = GetDlgItem (IDC_INS_PKG);
+  ins_filename = GetDlgItem (IDC_INS_FILE);
+  // Bars
+  ins_pprogress = GetDlgItem (IDC_INS_PPROGRESS);
+  ins_iprogress = GetDlgItem (IDC_INS_IPROGRESS);
+  ins_diskfull = GetDlgItem (IDC_INS_DISKFULL);
+  // Bar labels
+  ins_bl_package = GetDlgItem (IDC_INS_BL_PACKAGE);
+  ins_bl_total = GetDlgItem (IDC_INS_BL_TOTAL);
+  ins_bl_disk = GetDlgItem (IDC_INS_BL_DISK);
+}
+
+void
+ThreeBarProgressPage::SetText1 (const TCHAR * t)
+{
+  SetWindowText (ins_action, t);
+}
+
+void
+ThreeBarProgressPage::SetText2 (const TCHAR * t)
+{
+  SetWindowText (ins_pkgname, t);
+}
+
+void
+ThreeBarProgressPage::SetText3 (const TCHAR * t)
+{
+  SetWindowText (ins_filename, t);
+}
+
+void
+ThreeBarProgressPage::SetBar1 (long progress, long max)
+{
+  int percent = (int) (100.0 * ((double) progress) / (double) max);
+  SendMessage (ins_pprogress, PBM_SETPOS, (WPARAM) percent, 0);
+}
+
+void
+ThreeBarProgressPage::SetBar2 (long progress, long max)
+{
+  int percent = (int) (100.0 * ((double) progress) / (double) max);
+  SendMessage (ins_iprogress, PBM_SETPOS, (WPARAM) percent, 0);
+}
+
+void
+ThreeBarProgressPage::SetBar3 (long progress, long max)
+{
+  int percent = (int) (100.0 * ((double) progress) / (double) max);
+  SendMessage (ins_diskfull, PBM_SETPOS, (WPARAM) percent, 0);
+}
+
+void
+ThreeBarProgressPage::EnableSingleBar (bool enable)
+{
+  // Switch to/from single bar mode
+  ShowWindow (ins_bl_total, enable ? SW_HIDE : SW_SHOW);
+  ShowWindow (ins_bl_disk, enable ? SW_HIDE : SW_SHOW);
+  ShowWindow (ins_iprogress, enable ? SW_HIDE : SW_SHOW);
+  ShowWindow (ins_diskfull, enable ? SW_HIDE : SW_SHOW);
+}
+
+void
+ThreeBarProgressPage::OnActivate ()
+{
+  // Disable back and next buttons
+  GetOwner ()->SetButtons (0);
+
+  // Set all bars to 0
+  SetBar1 (0);
+  SetBar2 (0);
+  SetBar3 (0);
+
+  switch (task)
+    {
+    case WM_APP_START_SITE_INFO_DOWNLOAD:
+    case WM_APP_START_SETUP_INI_DOWNLOAD:
+      // For these tasks, show only a single progress bar.
+      EnableSingleBar ();
+      break;
+    default:
+      // Show the normal 3-bar view by default
+      EnableSingleBar (false);
+      break;
+    }
+
+  Window::PostMessage (task);
+}
+
+bool
+ThreeBarProgressPage::OnMessageApp (UINT uMsg, WPARAM wParam, LPARAM lParam)
+{
+  switch (uMsg)
+    {
+    case WM_APP_START_DOWNLOAD:
+      {
+	// Start the package download thread.
+	do_download (GetInstance (), GetHWND ());
+	break;
+      }
+    case WM_APP_DOWNLOAD_THREAD_COMPLETE:
+      {
+	if (lParam == IDD_S_INSTALL)
+	  {
+	    // Download is complete and we want to go on to the install.
+	    Window::PostMessage (WM_APP_START_INSTALL);
+	  }
+	else if (lParam != 0)
+	  {
+	    // Download failed for some reason, go back to site selection page
+	    GetOwner ()->SetActivePageByID (lParam);
+	  }
+	else
+	  {
+	    // Was a download-only, and is complete or failed.
+	    GetOwner ()->PressButton (PSBTN_CANCEL);
+	  }
+	break;
+      }
+    case WM_APP_START_INSTALL:
+      {
+	// Start the install thread.
+	do_install (GetInstance (), GetHWND ());
+	break;
+      }
+    case WM_APP_INSTALL_THREAD_COMPLETE:
+      {
+	// Re-enable and "Push" the Next button
+	GetOwner ()->SetButtons (PSWIZB_NEXT);
+	GetOwner ()->PressButton (PSBTN_NEXT);
+	break;
+      }
+    case WM_APP_START_SITE_INFO_DOWNLOAD:
+      {
+	do_download_site_info (GetInstance (), GetHWND ());
+	break;
+      }
+    case WM_APP_SITE_INFO_DOWNLOAD_COMPLETE:
+      {
+	GetOwner ()->SetActivePageByID (lParam);
+	break;
+      }
+    case WM_APP_START_SETUP_INI_DOWNLOAD:
+      {
+	do_ini (GetInstance (), GetHWND ());
+	break;
+      }
+    case WM_APP_SETUP_INI_DOWNLOAD_COMPLETE:
+      {
+	GetOwner ()->SetActivePageByID (lParam);
+	break;
+      }
+    default:
+      {
+	// Not handled
+	return false;
+      }
+    }
+
+  return true;
+}
Index: threebar.h
===================================================================
RCS file: threebar.h
diff -N threebar.h
--- /dev/null	Tue May  5 13:32:27 1998
+++ threebar.h	Thu Dec 20 04:36:03 2001
@@ -0,0 +1,81 @@
+#ifndef CINSTALL_THREEBAR_H
+#define CINSTALL_THREEBAR_H
+
+/*
+ * Copyright (c) 2001, Gary R. Van Sickle.
+ *
+ *     This program is free software; you can redistribute it and/or modify
+ *     it under the terms of the GNU General Public License as published by
+ *     the Free Software Foundation; either version 2 of the License, or
+ *     (at your option) any later version.
+ *
+ *     A copy of the GNU General Public License can be found at
+ *     http://www.gnu.org/
+ *
+ * Written by Gary R. Van Sickle <g.r.vansickle@worldnet.att.net>
+ *
+ */
+
+// This is the header for the ThreeBarProgressPage class.  It is a fairly generic
+// progress indicator property page with three progress bars.
+
+
+#include "win32.h"
+#include "proppage.h"
+
+#define WM_APP_START_DOWNLOAD              WM_APP+0
+#define WM_APP_DOWNLOAD_THREAD_COMPLETE    WM_APP+1
+#define WM_APP_START_INSTALL               WM_APP+2
+#define WM_APP_INSTALL_THREAD_COMPLETE     WM_APP+3
+#define WM_APP_START_SITE_INFO_DOWNLOAD    WM_APP+4
+#define WM_APP_SITE_INFO_DOWNLOAD_COMPLETE WM_APP+5
+#define WM_APP_START_SETUP_INI_DOWNLOAD    WM_APP+6
+#define WM_APP_SETUP_INI_DOWNLOAD_COMPLETE WM_APP+7
+
+class ThreeBarProgressPage:public PropertyPage
+{
+  HWND ins_dialog;
+  HWND ins_action;
+  HWND ins_pkgname;
+  HWND ins_filename;
+  HWND ins_pprogress;
+  HWND ins_iprogress;
+  HWND ins_diskfull;
+  HWND ins_bl_package;
+  HWND ins_bl_total;
+  HWND ins_bl_disk;
+
+  int task;
+
+  void EnableSingleBar (bool enable = true);
+
+public:
+    ThreeBarProgressPage ()
+  {
+  };
+  virtual ~ ThreeBarProgressPage ()
+  {
+  };
+
+  bool Create ();
+
+  virtual void OnInit ();
+  virtual void OnActivate ();
+  virtual bool OnMessageApp (UINT uMsg, WPARAM wParam, LPARAM lParam);
+
+  void SetText1 (const TCHAR * t);
+  void SetText2 (const TCHAR * t);
+  void SetText3 (const TCHAR * t);
+
+  void SetBar1 (long progress, long max = 100);
+  void SetBar2 (long progress, long max = 100);
+  void SetBar3 (long progress, long max = 100);
+
+  void SetActivateTask (int t)
+  {
+    task = t;
+  };
+};
+
+
+#endif // CINSTALL_THREEBAR_H
